OGRE: Ogre::Terrain::DefaultGpuBufferAllocator Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Member Functions | List of all members
Ogre::Terrain::DefaultGpuBufferAllocator Class Reference

Standard implementation of a buffer allocator which re-uses buffers. More...

`#include <OgreTerrain.h>`

Inheritance diagram for Ogre::Terrain::DefaultGpuBufferAllocator:
[legend]

## Public Member Functions
| DefaultGpuBufferAllocator ()
virtual | ~DefaultGpuBufferAllocator ()
void | allocateVertexBuffers (Terrain *forTerrain, size_t numVertices, HardwareVertexBufferSharedPtr &destPos, HardwareVertexBufferSharedPtr &destDelta)
| Allocate (or reuse) vertex buffers for a terrain LOD. More...
void | freeAllBuffers ()
| Free any buffers we're holding. More...
void | freeVertexBuffers (const HardwareVertexBufferSharedPtr &posbuf, const HardwareVertexBufferSharedPtr &deltabuf)
| Free (or return to the pool) vertex buffers for terrain. More...
HardwareIndexBufferSharedPtr | getSharedIndexBuffer (uint16 batchSize, uint16 vdatasize, size_t vertexIncrement, uint16 xoffset, uint16 yoffset, uint16 numSkirtRowsCols, uint16 skirtRowColSkip)
| Get a shared index buffer for a given number of settings. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
void | warmStart (size_t numInstances, uint16 terrainSize, uint16 maxBatchSize, uint16 minBatchSize)
| 'Warm start' the allocator based on needing x instances of terrain with the given configuration. More...

## Detailed Description

Standard implementation of a buffer allocator which re-uses buffers.

## Constructor & Destructor Documentation

## ◆ DefaultGpuBufferAllocator()

Ogre::Terrain::DefaultGpuBufferAllocator::DefaultGpuBufferAllocator | ( |  | ) |

## ◆ ~DefaultGpuBufferAllocator()

virtual Ogre::Terrain::DefaultGpuBufferAllocator::~DefaultGpuBufferAllocator | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ allocateVertexBuffers()

void Ogre::Terrain::DefaultGpuBufferAllocator::allocateVertexBuffers | ( | Terrain * | forTerrain,
|  | size_t | numVertices,
|  | HardwareVertexBufferSharedPtr & | destPos,
|  | HardwareVertexBufferSharedPtr & | destDelta
| ) |  |
| virtual

Allocate (or reuse) vertex buffers for a terrain LOD.

Parameters

  numVertices | The total number of vertices
  destPos | Pointer to a vertex buffer for positions, to be bound
  destDelta | Pointer to a vertex buffer for deltas, to be bound

Implements Ogre::Terrain::GpuBufferAllocator.

## ◆ freeAllBuffers()

void Ogre::Terrain::DefaultGpuBufferAllocator::freeAllBuffers | ( |  | ) |
| virtual

Free any buffers we're holding.

Implements Ogre::Terrain::GpuBufferAllocator.

## ◆ freeVertexBuffers()

void Ogre::Terrain::DefaultGpuBufferAllocator::freeVertexBuffers | ( | const HardwareVertexBufferSharedPtr & | posbuf,
|  | const HardwareVertexBufferSharedPtr & | deltabuf
| ) |  |
| virtual

Free (or return to the pool) vertex buffers for terrain.

Implements Ogre::Terrain::GpuBufferAllocator.

## ◆ getSharedIndexBuffer()

HardwareIndexBufferSharedPtr Ogre::Terrain::DefaultGpuBufferAllocator::getSharedIndexBuffer | ( | uint16 | batchSize,
|  | uint16 | vdatasize,
|  | size_t | vertexIncrement,
|  | uint16 | xoffset,
|  | uint16 | yoffset,
|  | uint16 | numSkirtRowsCols,
|  | uint16 | skirtRowColSkip
| ) |  |
| virtual

Get a shared index buffer for a given number of settings.

Remarks
  Since all index structures are the same at the same LOD level and relative position, we can share index buffers. Therefore the buffer returned from this method does not need to be 'freed' like the vertex buffers since it is never owned.

Parameters

  batchSize | The batch size along one edge
  vdatasize | The size of the referenced vertex data along one edge
  vertexIncrement | The number of vertices to increment for each new indexed row / column
  xoffset | The x offset from the start of vdatasize, at that resolution
  yoffset | The y offset from the start of vdatasize, at that resolution
  numSkirtRowsCols | Number of rows and columns of skirts
  skirtRowColSkip | The number of rows / cols to skip in between skirts

Implements Ogre::Terrain::GpuBufferAllocator.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ warmStart()

void Ogre::Terrain::DefaultGpuBufferAllocator::warmStart | ( | size_t | numInstances,
|  | uint16 | terrainSize,
|  | uint16 | maxBatchSize,
|  | uint16 | minBatchSize
| ) |  |

'Warm start' the allocator based on needing x instances of terrain with the given configuration.

The documentation for this class was generated from the following file:

- OgreTerrain.h